## calico 3.31.1+ds

=== debian/changelog ===
calico (3.31.1+ds-0kali1) kali-dev; urgency=medium

  * New upstream version 3.31.1+ds

 -- Sophie Brun <sophie@kali.org>  Mon, 17 Nov 2025 17:31:30 +0100
