## calico 3.31.2+ds

=== debian/changelog ===
calico (3.31.2+ds-0kali1) kali-dev; urgency=medium

  * New upstream version 3.31.2+ds

 -- Sophie Brun <sophie@kali.org>  Tue, 02 Dec 2025 14:07:39 +0100
