=== debian/changelog ===
calico (3.31.3+ds-0kali1) kali-dev; urgency=medium

  * New upstream version 3.31.3+ds
  * Update debian/vendor
  * Do not ignore vendor dir
  * Refresh patches
  * Fix the build for the new release
  * Update debian/copyright
  * Bump Standards-Version to 4.7.3
  * Update debian/watch to Version 5

 -- Sophie Brun <sophie@kali.org>  Fri, 16 Jan 2026 12:03:19 +0100
