=== debian/control ===
Source: calico
Section: misc
Priority: optional
Maintainer: Kali Developers <devel@kali.org>
Uploaders: Sophie Brun <sophie@kali.org>
Build-Depends:
 debhelper-compat (= 13),
 golang
Standards-Version: 4.7.3
Homepage: https://github.com/projectcalico/calico
Vcs-Browser: https://gitlab.com/kalilinux/packages/calico
Vcs-Git: https://gitlab.com/kalilinux/packages/calico.git

Package: calicoctl
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description:  networking and network security solution for Kubernetes
 This package contains the command line tool for calico. Calico is a widely
 adopted, battle-tested open source networking and network security solution
 for Kubernetes, virtual machines, and bare-metal workloads.
