=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE = 1
include /usr/share/dpkg/pkg-info.mk

export GOCACHE=$(CURDIR)/vendor
export GOPATH=$(CURDIR)/vendor
export GO111MODULE=off
export GOPROXY=off
export MODULE_PATH=$(GOPATH)/src

%:
	dh $@

execute_after_dh_auto_clean:
	rm -rf vendor

override_dh_auto_build:
	# we just want calicoctl in Kali
	mkdir -p $(MODULE_PATH)
	cp -r debian/vendor/* $(MODULE_PATH)

	mkdir -p $(MODULE_PATH)/github.com/projectcalico/calico
	cp -r calicoctl $(MODULE_PATH)/github.com/projectcalico/calico
	cp -r libcalico-go $(MODULE_PATH)/github.com/projectcalico/calico
	cp -r crypto $(MODULE_PATH)/github.com/projectcalico/calico
	cp -r pkg $(MODULE_PATH)/github.com/projectcalico/calico
	cp -r kube-controllers $(MODULE_PATH)/github.com/projectcalico/calico

	cd $(CURDIR)/calicoctl && go build -v -o bin/calicoctl -ldflags "-X github.com/projectcalico/calico/calicoctl/calicoctl/commands.VERSION=upstream/$(DEB_VERSION_UPSTREAM) -X github.com/projectcalico/calico/calicoctl/calicoctl/commands/common.VERSION=upstream/$(DEB_VERSION_UPSTREAM)" "./calicoctl/calicoctl.go"

override_dh_auto_test:

override_dh_dwz:
	# fails with "dwz: debian/calicoctl/usr/bin/calicoctl: Found
	# compressed .debug_abbrev section, not attempting dwz
	# compression"
