## calico 3.31.4%2Bds

=== networking-calico/Makefile ===
--- 
+++ 
@@ -17,9 +17,6 @@
 tox-%: upper-constraints-%.txt
 	$(MAKE) tox PIP_CONSTRAINT=/code/upper-constraints-$*.txt
 
-upper-constraints-yoga.txt:
-	curl -fsSL --retry 5 https://releases.openstack.org/constraints/upper/yoga -o $@
-
 upper-constraints-caracal.txt:
 	curl -fsSL --retry 5 https://raw.githubusercontent.com/openstack/requirements/refs/heads/unmaintained/2024.1/upper-constraints.txt -o $@
